use std::collections::HashMap;
use domo_proto::identifier::Identifier;
use self::property::Property;

pub mod property;

pub struct Node {
    // Identifier of the node
    pub identifier: Identifier,
    /// According to the domo protocol spec:
    /// Strings have a limit of 32 bytes.
    /// Theoretically there is a limit of 0xFFFFFFFF (4294967295) properties. 
    pub properties: HashMap<String, Property>,
    /// Domo protocol allows for nodes under nodes therefore there is a hashmap for it.
    pub nodes: HashMap<Identifier, Node>
}

impl Node {
    pub fn new(identifier: Identifier) -> Self {
        Self {
            identifier,
            properties: HashMap::new(),
            nodes: HashMap::new()
        }
    }
}